///////////////
// IanniX
///////////////

////////////////////////////
// MAIN FILE
////////////////////////////

#include "NxApplication.h"

//const int OpenEventID = QEvent::User + 100;

class OpenEvent : public QEvent
{
public:
    OpenEvent(const QString &fileName) : QEvent( QEvent::User ), file(fileName) {}
    QString fileName() const { return file; }
    
private:
    QString file;
};

NxApplication::NxApplication(int argc, char *argv[])
    : QApplication(argc, argv), viewer(0)
{
    AEInstallEventHandler(kCoreEventClass, kAEOpenDocuments,
                          NxApplication::appleEventHandler, 0, false);
}

NxApplication::~NxApplication()
{
    AERemoveEventHandler(kCoreEventClass, kAEOpenDocuments,
                         NxApplication::appleEventHandler, false);
}

OSErr NxApplication::appleEventHandler(const AppleEvent *ae, AppleEvent *, long)
{
    AEDescList docs;
    if (AEGetParamDesc(ae, keyDirectObject, typeAEList, &docs) == noErr) {
        long cnt = 0;
        AECountItems(&docs, &cnt);
        UInt8 strBuffer[256];
        for (int i = 0; i < cnt; i++) {
            FSRef ref;
            if (AEGetNthPtr(&docs, i+1, typeFSRef, 0, 0, &ref, sizeof(ref), 0) != noErr)
                continue;
            if (FSRefMakePath(&ref, strBuffer, 256) == noErr) {
                OpenEvent event(QString::fromUtf8(reinterpret_cast<char *>(strBuffer)));
                QApplication::sendEvent(qApp, &event);
            }
        }
    }
    return noErr;
}

void NxApplication::customEvent(QEvent *ev)
{
    if (ev->type() == QEvent::User)
        viewer->openFinderScore( static_cast<OpenEvent *>(ev)->fileName() );
}

void NxApplication::setNxView(NxView *nxViewer)
{
    viewer = nxViewer;
}