///////////////
// IanniX
///////////////

////////////////////////////
// NxControlCenterDelegate.cpp
////////////////////////////

#include "NxControlCenterDelegate.h"

NxControlCenterDelegate::NxControlCenterDelegate(QObject *parent) 
	: QItemDelegate(parent) 
{
	controlCenter = (NxControlCenter*)parent ;
}

void NxControlCenterDelegate::setObjectType( int inType )
{
	objType = inType ;
}

QWidget *NxControlCenterDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &, const QModelIndex & index) const
{
//	QSpinBox *editor = new QSpinBox(parent);
//	editor->installEventFilter( const_cast<NxControlCenterDelegate*>(this) );
//	return editor;
	switch(objType) {
		case 0: // CURVE
			switch( index.column() ) {
				case 6: {
					QComboBox *curvStyle = new QComboBox(parent) ;
					QStringList strList ;
					strList << "Lines" << "Splines" ;
					curvStyle->addItems(strList) ;
					curvStyle->setFrame( false );
					curvStyle->installEventFilter( const_cast<NxControlCenterDelegate*>(this) );
					int indval = index.model()->data( index, Qt::EditRole ).toInt() ;
					curvStyle->setCurrentIndex( indval );
					return curvStyle; }
				break ;
				default: {
					QLineEdit* lineEdit = new QLineEdit( parent );
					lineEdit->setFrame( false );
					lineEdit->installEventFilter( const_cast<NxControlCenterDelegate*>(this) );
					return lineEdit; }
				break ;
			}
		break;
		case 2: { // CURSOR
			QStringList strList ;
			int indval ;
			switch( index.column() ) {
				case 8: {
					QComboBox *forwC = new QComboBox(parent) ;
					strList << "Forward" << "Backward" ;
					forwC->addItems(strList) ;
					forwC->setFrame( false );
					forwC->installEventFilter( const_cast<NxControlCenterDelegate*>(this) );
					int indval = index.model()->data( index, Qt::EditRole ).toInt() ;
					forwC->setCurrentIndex( indval );
					return forwC; }
				break ;
				case 9: {
					QComboBox *modeC = new QComboBox(parent) ;
					strList << "Single" << "Repeat" << "Fwd / Bckwd" ;
					modeC->addItems(strList) ;
					modeC->setFrame( false );
					modeC->installEventFilter( const_cast<NxControlCenterDelegate*>(this) );
					indval = index.model()->data( index, Qt::EditRole ).toInt() ;
					modeC->setCurrentIndex( indval );
					return modeC; }
				break ;
				default: {
					QLineEdit* lineEdit = new QLineEdit( parent );
					lineEdit->setFrame( false );
					lineEdit->installEventFilter( const_cast<NxControlCenterDelegate*>(this) );
					return lineEdit; }
				break ;
			}
		}
		break ;
		default: { // TRAJECT or TRIGGER
			QLineEdit* lineEdit = new QLineEdit( parent );
			lineEdit->setFrame( false );
			lineEdit->installEventFilter( const_cast<NxControlCenterDelegate*>(this) );
			return lineEdit; }
		break ;
	}

}

void NxControlCenterDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
//	int value = index.model()->data(index, Qt::DisplayRole).toInt();
//	QSpinBox *spinBox = static_cast<QSpinBox*>(editor);
//	spinBox->setValue(value);
	switch(objType) {
		case 0: // CURVE
			switch( index.column() ) {
				case 6: {
					QComboBox* comboBox = static_cast<QComboBox*>(editor);
					int indval = index.model()->data( index, Qt::EditRole ).toInt() ;
					comboBox->setCurrentIndex( indval );
					comboBox->showPopup(); }
				break ;
				default:
					QLineEdit* lineEdit = static_cast<QLineEdit*>(editor);
					lineEdit->setText( index.model()->data(index, Qt::DisplayRole).toString() );
				break ;
			}
		break;
		case 2: // CURSOR
			switch( index.column() ) {
				case 8:
				case 9: {
					QComboBox* comboBox = static_cast<QComboBox*>(editor);
					int indval = index.model()->data( index, Qt::EditRole ).toInt() ;
					comboBox->setCurrentIndex( indval );
					comboBox->showPopup(); }		
				break ;
				default: {
					QLineEdit* lineEdit = static_cast<QLineEdit*>(editor);
					lineEdit->setText( index.model()->data(index, Qt::DisplayRole).toString() ); }
				break ;
			}		
		break ;
		default: { // TRAJECT or TRIGGER
			QLineEdit* lineEdit = static_cast<QLineEdit*>(editor);
			lineEdit->setText( index.model()->data(index, Qt::DisplayRole).toString() ); }	
		break ;
	}

}

void NxControlCenterDelegate::setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const
{
//	QSpinBox *spinBox = static_cast<QSpinBox*>(editor);
//	spinBox->interpretText();
//	int value = spinBox->value();
//	model->setData(index, value);
	switch(objType) {
		case 0: // CURVE
			switch( index.column() ) {
				case 6: {
					QComboBox* comboBox = static_cast<QComboBox*>(editor);
					controlCenter->updateCurveDrawStyle( index.row(), comboBox->currentIndex() );
					model->setData( index, comboBox->itemText( comboBox->currentIndex() ) ); }
				break ;
				default: {
					QLineEdit* lineEdit = static_cast<QLineEdit*>(editor);
					model->setData( index, lineEdit->text() ); }
				break ;
			}
		break;
		case 2: // CURSOR
			switch( index.column() ) {
				case 8:
				case 9: {
					QComboBox* comboBox = static_cast<QComboBox*>(editor);
					controlCenter->updateCursorModes( index.column(), index.row(), comboBox->currentIndex() );
					model->setData( index, comboBox->itemText( comboBox->currentIndex() ) ); }			
				break ;
				default: {
					QLineEdit* lineEdit = static_cast<QLineEdit*>(editor);
					model->setData( index, lineEdit->text() ); }
				break ;
			}
		break ;
		default: { // TRAJECT or TRIGGER
			QLineEdit* lineEdit = static_cast<QLineEdit*>(editor);
			model->setData( index, lineEdit->text() ); }
		break ;
	}

}

void NxControlCenterDelegate::updateEditorGeometry(QWidget *editor, const QStyleOptionViewItem &option, const QModelIndex &) const
{
     editor->setGeometry(option.rect);
}

