///////////////
// IanniX
///////////////

////////////////////////////
// NxObjectEditor.h
////////////////////////////

#ifndef NXOBJECTEDITOR_H
#define NXOBJECTEDITOR_H

#include <QtGui>
#include "../graphics/opengl/NxGLScore.h"
#include "../base/atoms/NxTypes.h"
#include "../base/atoms/NxObject.h"

class NxGLScore ;

class NxObjectEditor : public QDialog
{
	Q_OBJECT

 public:
	NxObjectEditor( NxGLScore* parent );
  	~NxObjectEditor();
  
	void showEditGroup() ;
	void showEditSelection( QList<NxObject*> inSelected ) ;
	void showEditObject( NxObject* inObject ) ;
	
 public slots:
 	
 protected:
 
	void firstBuildItems() ;
	void setDefaultColors() ;
	
	void setChecked() ;
	void setDefaultValues() ;
	void setObjectValues( NxObject* inObject ) ;
	void setEdited( QList<NxObject*> inList ) ;
	
	QList<NxObject*>	objectList ;	// Objects to modify
	NxGLScore			*parentGLBox ;
	
	bool	applyAll ;
	bool	circleOnlySelected ;
	QPalette		cGray, cRed, cLight, cDark ;
	
	QDialog			*editGroupDialog ;
	
	QGroupBox		*Gosc ;	
	QGroupBox		*Gmove, *Gtype, *GcurvesBounds, *Gbounds, *Gcheck, *Gsettings, *Gchoice, *Gparam, *Gcurves, *Gtrajects, *Gtriggers, *Gcursors ;
	
	// FILTERS
	QLineEdit		*fLayerF, *fGroupF ;		
	QCheckBox		*trajC, *cursC, *curvC, *trigC ;
	QComboBox		*applyOnGroupIDC, *applyOnLayerC, *shiftAngleC ;
	// PARAMETERS	
	QCheckBox		*setActC, *newNameC, *newLayerC, *newGroupIDC, *newCustomIDC ;
	QLineEdit		*newNameL, *newGroupIDL, *newLayerL, *newCustomIDL ;
	QLineEdit		*xtF, *ytF, *ztF ;
	QCheckBox		*xtC, *ytC, *ztC ;
	QComboBox		*actC, *shiftXC, *shiftYC, *shiftZC ;
	QPushButton		*colorB ;
	QCheckBox		*colorC ;
	// CURSORS
	QCheckBox		*initAngleC, *finalAngleC, *initOffsetC, *finalOffsetC, *speedC, *widthC, *whenFinishedC, *forwardC, *modeC ;	
	QLineEdit		*initAngleL, *finalAngleL, *initOffsetL, *finalOffsetL, *speedL, *widthL ;	
	QComboBox		*playMuteC, *forwardQ, *modeQ ;	
	// CURVES
	QCheckBox		*setScaleC, *setStyleC, *setAngleC, *scanPeriodC, *flattenC ;
	QComboBox		*setStyleQ, *shiftPeriodC, *shiftScaleC ;	
	QLineEdit		*newScaleF, *newAngleF ;
	QSpinBox		*scanPeriodL ;
	QCheckBox		*setBoundsC, *cRescale, *cRescaleG, *cRescaleTrans ;
	QLineEdit		*rMinF, *rMaxF ;
	// TRIGGERS + TRAJECTS
	QCheckBox		*intValueC, *lengthC, *radiusC ;										
	QLineEdit		*intValueL, *lengthL, *radiusL ;
	// OSC									
	QCheckBox		*setOscFormatC, *setIPC, *setPortC ;	
	QLineEdit		*newOscFormatL, *newIPL, *newPortL ;
	
	////////////// COLOR MENUS
	Color			objectPickedColor ;
	QColorDialog	*colDialogPicker ;
	bool			dialogColorPicked ;
	
 protected slots:
	
	virtual void closeEvent( QCloseEvent* e );
	
	virtual void applyChanges() ;
	
	virtual void setEditLengthEnabled( bool flag ) ;
	virtual void setEditRadiusEnabled( bool flag ) ;
	
	virtual void setEditGroupsEnabled( bool ) ;
	
	virtual void setEditBoundsEnabled( bool flag ) ;
	virtual void setEditFlattenEnabled( bool flag ) ;
	virtual void setEditByGroupEnabled( int flag ) ;
	virtual void setEditByLayerEnabled( int flag ) ;
	
	virtual void pickObjectColor() ;
	
};

#endif

