///////////////
// IanniX
///////////////

////////////////////////////
// NxOscConsole.h
////////////////////////////

#ifndef NXOSCCONSOLE_H
#define NXOSCCONSOLE_H

#include "../graphics/opengl/NxGLScore.h"
#include "../atoms/NxTypes.h"

#include <QtGui>
#include <math.h>

class NxGLScore ;
class NxScore ;
class NxScheduler ;

class NxOscConsole : public QThread
{
  Q_OBJECT

 public:
	NxOscConsole( NxGLScore* parent = 0, NxScheduler* inScheduler = 0 );
  	~NxOscConsole();
	
	void openWindow() ;
	
 public slots :
 
	void run();	
	
	virtual void startOutListening() ;
	virtual void stopOutListening() ;
	
	virtual void addOscInMessage( QString inStr, QList<QVariant> argList, bool isOK ) ;
	virtual void addOscOutCurveMessage( curveOSC inMess ) ;
	virtual void addOscOutTriggerMessage( triggerOSC inMess ) ;
	
 protected:

	
 protected slots:
	
	virtual void clearMessages() ;
	virtual void roundValues( bool flag ) ;
	
 private:
	
	float rounder( float inVal ) ;
	
	int		maxIn, maxCurv, maxTrig ;
	
	QPushButton			*stopB, *startB ;
	
	QString				space ;
	QCheckBox			*roundC ;
	QListWidget			*inView, *outCurveView, *outTriggerView ;
	QDialog				*console ;
	
	bool	inListening ;
	bool	outListening ;
	bool	roundV ;
	
  	// Partition pointer
  	NxScore*		score;
  	NxGLScore*		parentGLBox;
	NxScheduler*	timeScheduler ;
	
};

#endif

