///////////////
// IanniX
///////////////

////////////////////////////
// NxPreferences.h
////////////////////////////

#ifndef NXPREFERENCES_H
#define NXPREFERENCES_H

#include <QtGui>
#include "../graphics/opengl/NxGLScore.h"
#include "../base/atoms/NxTypes.h"
#include "../base/atoms/NxObject.h"

class NxGLScore ;

class NxPreferences : public QDialog
{
	Q_OBJECT

 public:
	NxPreferences( NxGLScore* parent );
  	~NxPreferences();
	
 public slots:
 	
	virtual void openPreferences() ;
	
 protected:
 
	void firstBuildItems() ;
	void setValues() ;
	
	NxGLScore	*parentGLBox ;
	NxEnv		localEnv ;
	
	//// SLIDERS
	QSlider	*namesOpSlider, *zonesOpSlider, *gridOpSlider ;
	QLabel	*nameL, *heightL, *lengthL, *IDL;
	QLabel	*hostL, *outportL, *ivalueL ;
	//// FIELDS
	QLineEdit	*nameF, *heightF, *lengthF, *IDF;
	QLineEdit	*tempoF ;
	QSpinBox	*sStepF, *dStepF, *defaultSpatialPeriod ;
	QCheckBox	*manualSchStep ;
	QLineEdit	*configIPF, *hostF, *outPortF, *inPortF, *mformat1F, *mformat2F, *ivalueF;
	QLineEdit	*mapp1F, *mapp2F ;
	////////// PREFS ////// Curves / Trigger OSC sending options
	QCheckBox	*oscScCRID, *oscScCID, *oscScCGID, *oscScRID, *oscScID, *oscScGID, *oscScA, *oscScV, *oscScX, *oscScY, *oscScZ ;	
	QCheckBox	*oscStCRID, *oscStCID, *oscStCGID, *oscStRID, *oscStID, *oscStGID, *oscStV, *oscStX, *oscStY, *oscStZ ;
	QLabel		*oscCurveMessageL, *oscTriggerMessageL ;
	////////// PREFS ////// DISPLAY checkboxes
	QCheckBox	*sWorkspace, *sScreenInfos, *sNames, *sGrid, *sCrosses, *sCircles, *sRectangles, *sCursZones ;
	////////// PREFS ////// COLOR
	QPushButton *chooseScoreColor, *chooseBackColor, *chooseGridColor ;
  	QColorDialog *colorPicker ;
	Color pickedBackColor, pickedScoreColor, pickedGridColor ;
	bool backColorPicked, scoreColorPicked, gridColorPicked ;
	
 protected slots:
		
	virtual void updateOscMessages(QString) ;
	virtual void updateOscCurveMessage(bool) ;
	virtual void updateOscTriggerMessage(bool) ;
	virtual void pickBackColor() ;
	virtual void pickScoreColor() ;
	virtual void pickGridColor() ;
	virtual void setGridOpacity( int inOp ) ;
	virtual void setCursorZonesOpacity( int inOp ) ;
	virtual void setNamesOpacity( int inOp ) ;
	virtual void setPreferences();
	
};

#endif

